<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/printmatinfo.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>printmatinfo.c</h1><a href="printmatinfo_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2006-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">/* $Id: printmatinfo.c 2962 2010-02-04 19:50:44Z scholz $ */</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a><a class="code" href="util_8h.html#ad26766c91dfc88c559fd736d1bb6e064">00028</a> <span class="keywordtype">int</span> <a class="code" href="printmatinfo_8c.html#ad26766c91dfc88c559fd736d1bb6e064">PrintMatInfo</a>(Mat A,MatInfoType flag)
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030   <span class="keywordtype">int</span> ierr;
<a name="l00031"></a>00031   <span class="keywordtype">int</span> rank,size;
<a name="l00032"></a>00032   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00033"></a>00033   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   PetscTruth oinfo;
<a name="l00036"></a>00036   PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-info&quot;</span>,&amp;oinfo);
<a name="l00037"></a>00037 <span class="keywordflow">if</span> (oinfo) {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   MatInfo <a class="code" href="namespacegmshtoucd.html#af68c1546c900f7a17a20835183320d61">info</a>;
<a name="l00040"></a>00040   ierr = MatGetInfo(A,MAT_GLOBAL_SUM,&amp;info);CHKERRQ(ierr);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   PetscErrorCode (*printffunc)(MPI_Comm comm,<span class="keyword">const</span> <span class="keywordtype">char</span> format[],...);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (flag==MAT_LOCAL) {
<a name="l00045"></a>00045     printffunc=PetscSynchronizedPrintf;
<a name="l00046"></a>00046   }
<a name="l00047"></a>00047   <span class="keywordflow">else</span> {
<a name="l00048"></a>00048     printffunc=PetscPrintf;
<a name="l00049"></a>00049   }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="preprocessor">#if PETSC_VERSION &gt;= 300</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>  <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> grows,gcols;
<a name="l00053"></a>00053   ierr = MatGetSize(A,&amp;grows,&amp;gcols);CHKERRQ(ierr);
<a name="l00054"></a>00054   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; global rows and columns: %g x %g\n&quot;</span>,
<a name="l00055"></a>00055     rank,grows,gcols);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> lrows,lcols;
<a name="l00058"></a>00058   ierr = MatGetLocalSize(A,&amp;lrows,&amp;lcols);CHKERRQ(ierr);
<a name="l00059"></a>00059   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; local rows and columns: %g x %g (%g %%)\n&quot;</span>,
<a name="l00060"></a>00060     rank,lrows,lcols,100.0*lrows/grows);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a> bs;
<a name="l00063"></a>00063   ierr = MatGetBlockSize(A,&amp;bs);CHKERRQ(ierr);
<a name="l00064"></a>00064   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; block size %g\n&quot;</span>,
<a name="l00065"></a>00065     rank,bs);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00066"></a>00066 <span class="preprocessor">#else</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>  printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; global rows and columns: %g x %g\n&quot;</span>,
<a name="l00068"></a>00068     rank,info.rows_global,info.columns_global);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00069"></a>00069   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; local rows and columns: %g x %g (%g %%)\n&quot;</span>,
<a name="l00070"></a>00070     rank,info.rows_local,info.columns_local,100.0*info.rows_local/info.rows_global);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00071"></a>00071   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; block size %g\n&quot;</span>,
<a name="l00072"></a>00072     rank,info.block_size);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00073"></a>00073 <span class="preprocessor">#endif</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span>  printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; nonzeroes allocated: %g (%g %%)  used: %g (%g %%)  unneeded: %g (%g %%)\n&quot;</span>,
<a name="l00075"></a>00075     rank,info.nz_allocated,100.0*info.nz_allocated/info.nz_used,info.nz_used,100.0*info.nz_used/info.nz_used,info.nz_unneeded,100.0*info.nz_unneeded/info.nz_used);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00076"></a>00076   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; memory allocated: %g\n&quot;</span>,
<a name="l00077"></a>00077     rank,info.memory);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00078"></a>00078   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; number of matrix assemblies called: %g\n&quot;</span>,
<a name="l00079"></a>00079     rank,info.assemblies);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00080"></a>00080   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; number of mallocs during MatSetValues: %g\n&quot;</span>,
<a name="l00081"></a>00081     rank,info.mallocs);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00082"></a>00082   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; fill_ratio_given: %g  fill_ratio_needed: %g  for LU/ILU\n&quot;</span>,
<a name="l00083"></a>00083     rank,info.fill_ratio_given,info.fill_ratio_needed);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00084"></a>00084   printffunc(PETSC_COMM_WORLD,<span class="stringliteral">&quot;  &lt;%i&gt; number of mallocs during factorization: %g\n&quot;</span>,
<a name="l00085"></a>00085     rank,info.factor_mallocs);<span class="keywordflow">if</span> (flag==MAT_LOCAL) PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="keywordflow">return</span>(0);
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="util_8h.html#a8c62a6053be02438e1bf2da1efa06f1f">00092</a> <span class="keywordtype">int</span> <a class="code" href="printmatinfo_8c.html#a8c62a6053be02438e1bf2da1efa06f1f">PrintMatInfoAll</a>(Mat A)
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   <span class="keywordtype">int</span> ierr;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordtype">int</span> rank,size;
<a name="l00097"></a>00097   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00098"></a>00098   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   PetscTruth <a class="code" href="namespacegmshtoucd.html#af68c1546c900f7a17a20835183320d61">info</a>;
<a name="l00101"></a>00101   PetscOptionsHasName(PETSC_NULL,<span class="stringliteral">&quot;-info&quot;</span>,&amp;info);
<a name="l00102"></a>00102 <span class="keywordflow">if</span> (info) {
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">if</span> (size&gt;1) {
<a name="l00105"></a>00105     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;local matrix info:\n&quot;</span>);
<a name="l00106"></a>00106     ierr = <a class="code" href="printmatinfo_8c.html#ad26766c91dfc88c559fd736d1bb6e064">PrintMatInfo</a>(A,MAT_LOCAL);CHKERRQ(ierr);
<a name="l00107"></a>00107     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;global max. matrix info:\n&quot;</span>);
<a name="l00108"></a>00108     ierr = <a class="code" href="printmatinfo_8c.html#ad26766c91dfc88c559fd736d1bb6e064">PrintMatInfo</a>(A,MAT_GLOBAL_MAX);CHKERRQ(ierr);
<a name="l00109"></a>00109   }
<a name="l00110"></a>00110   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;global sum matrix info:\n&quot;</span>);
<a name="l00111"></a>00111   ierr = <a class="code" href="printmatinfo_8c.html#ad26766c91dfc88c559fd736d1bb6e064">PrintMatInfo</a>(A,MAT_GLOBAL_SUM);CHKERRQ(ierr);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">return</span>(0);
<a name="l00116"></a>00116 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

